---
title: DragEvent()
slug: Web/API/DragEvent/DragEvent
tags:
  - API
  - Constructor
  - DOM
  - Reference
  - drag and drop
---
<div>{{APIRef("HTML Drag and Drop API")}}</div>

<p>This constructor is used to create a synthetic {{domxref("DragEvent")}} object.</p>

<p class="note">Although this interface has a constructor, it is not possible to create a useful {{domxref("DataTransfer")}} object from script, since {{domxref("DataTransfer")}} objects have a processing and security model that is coordinated by the browser during drag-and-drops.</p>

<p class="note">This interface inherits properties from {{domxref("MouseEvent")}} and {{domxref("Event")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"> <em>event</em> = new DragEvent(<em>type</em>, <em>DragEventInit</em>);</pre>

<h3 id="Arguments">Arguments</h3>

<dl>
 <dt><em>type</em></dt>
 <dd>Is a <code>{{domxref("DOMString")}}</code> representing the name of the event (see <a href="/Web/API/DragEvent#Event_types">DragEvent event types</a>).</dd>
 <dt><em>DragEventInit</em>{{optional_inline}}</dt>
 <dd>Is a <code>DragEventInit</code> dictionary, having the following fields:

 <ul>
  <li><code>"dataTransfer"</code>, optional and defaults to <code>"null"</code>. The type is <code>{{domxref("DataTransfer")}}</code>.</li>
 </ul>
 </dd>
</dl>

<p class="note">The <code>DragEventInit</code> dictionary inherits from the {{domxref("MouseEvent.MouseEvent","MouseEventInit dictionary")}}.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("HTML WHATWG", "interaction.html#the-dragevent-interface", "DragEvent")}}</td>
   <td>{{Spec2("HTML WHATWG")}}</td>
   <td> </td>
  </tr>
  <tr>
   <td>{{SpecName("HTML5.1", "editing.html#the-dragevent-interface", "DragEvent")}}</td>
   <td>{{Spec2("HTML5.1")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DragEvent.DragEvent")}}</p>
